Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4502)
@@ -1551,4 +1725,197 @@
 
        ENDIF
+
+!
+!--    If required, calculate prognostic equations for ice crystal content
+!--    and ice crystal concentration
+       IF ( microphysics_ice_extension )  THEN
+
+          CALL cpu_log( log_point(70), 'qi-equation', 'start' )
+
+!
+!--       Calculate prognostic equation for ice crystal content
+          sbt = tsc(2)
+          IF ( scalar_advec == 'bc-scheme' )  THEN
+
+             IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--             Bott-Chlond scheme always uses Euler time step. Thus:
+                sbt = 1.0_wp
+             ENDIF
+             tend = 0.0_wp
+             CALL advec_s_bc( qi, 'qi' )
+
+          ENDIF
+
+!
+!--       qi-tendency terms with no communication
+          IF ( scalar_advec /= 'bc-scheme' )  THEN
+             tend = 0.0_wp
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws( advc_flags_s, qi, 'qi',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
+                ELSE
+                   CALL advec_s_pw( qi )
+                ENDIF
+             ELSE
+                CALL advec_s_up( qi )
+             ENDIF
+          ENDIF
+
+          CALL diffusion_s( qi,                                                &
+                            surf_def_h(0)%qisws, surf_def_h(1)%qisws,          &
+                            surf_def_h(2)%qisws,                               &
+                            surf_lsm_h%qisws,    surf_usm_h%qisws,             &
+                            surf_def_v(0)%qisws, surf_def_v(1)%qisws,          &
+                            surf_def_v(2)%qisws, surf_def_v(3)%qisws,          &
+                            surf_lsm_v(0)%qisws, surf_lsm_v(1)%qisws,          &
+                            surf_lsm_v(2)%qisws, surf_lsm_v(3)%qisws,          &
+                            surf_usm_v(0)%qisws, surf_usm_v(1)%qisws,          &
+                            surf_usm_v(2)%qisws, surf_usm_v(3)%qisws )
+
+!
+!--       Prognostic equation for ice crystal mixing ratio
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                !following directive is required to vectorize on Intel19
+                !DIR$ IVDEP
+                DO  k = nzb+1, nzt
+                   qi_p(k,j,i) = qi(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
+                                                      tsc(3) * tqi_m(k,j,i) )  &
+                                                    - tsc(5) * rdf_sc(k) *     &
+                                                               qi(k,j,i)       &
+                                             )                                 &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                                          )
+                   IF ( qi_p(k,j,i) < 0.0_wp )  qi_p(k,j,i) = 0.0_wp
+                ENDDO
+             ENDDO
+          ENDDO
+
+!
+!--       Calculate tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb+1, nzt
+                         tqi_m(k,j,i) = tend(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSEIF ( intermediate_timestep_count < &
+                      intermediate_timestep_count_max )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb+1, nzt
+                         tqi_m(k,j,i) =   -9.5625_wp * tend(k,j,i)             &
+                                         + 5.3125_wp * tqi_m(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDIF
+
+          CALL cpu_log( log_point(70), 'qi-equation', 'stop' )
+
+          CALL cpu_log( log_point(69), 'ni-equation', 'start' )
+!
+!--       Calculate prognostic equation for ice crystal concentration
+          sbt = tsc(2)
+          IF ( scalar_advec == 'bc-scheme' )  THEN
+
+             IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--             Bott-Chlond scheme always uses Euler time step. Thus:
+                sbt = 1.0_wp
+             ENDIF
+             tend = 0.0_wp
+             CALL advec_s_bc( ni, 'ni' )
+
+          ENDIF
+
+!
+!--       ni-tendency terms with no communication
+          IF ( scalar_advec /= 'bc-scheme' )  THEN
+             tend = 0.0_wp
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws( advc_flags_s, ni, 'ni',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
+                ELSE
+                   CALL advec_s_pw( ni )
+                ENDIF
+             ELSE
+                CALL advec_s_up( ni )
+             ENDIF
+          ENDIF
+
+          CALL diffusion_s( ni,                                                &
+                            surf_def_h(0)%nisws, surf_def_h(1)%nisws,          &
+                            surf_def_h(2)%nisws,                               &
+                            surf_lsm_h%nisws,    surf_usm_h%nisws,             &
+                            surf_def_v(0)%nisws, surf_def_v(1)%nisws,          &
+                            surf_def_v(2)%nisws, surf_def_v(3)%nisws,          &
+                            surf_lsm_v(0)%nisws, surf_lsm_v(1)%nisws,          &
+                            surf_lsm_v(2)%nisws, surf_lsm_v(3)%nisws,          &
+                            surf_usm_v(0)%nisws, surf_usm_v(1)%nisws,          &
+                            surf_usm_v(2)%nisws, surf_usm_v(3)%nisws )
+
+!
+!--       Prognostic equation for ice crystal concentration
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                !following directive is required to vectorize on Intel19
+                !DIR$ IVDEP
+                DO  k = nzb+1, nzt
+                   ni_p(k,j,i) = ni(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
+                                                      tsc(3) * tni_m(k,j,i) )  &
+                                                    - tsc(5) * rdf_sc(k) *     &
+                                                               ni(k,j,i)       &
+                                             )                                 &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                                          )
+                   IF ( ni_p(k,j,i) < 0.0_wp )  ni_p(k,j,i) = 0.0_wp
+                ENDDO
+             ENDDO
+          ENDDO
+
+!
+!--       Calculate tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb+1, nzt
+                         tni_m(k,j,i) = tend(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSEIF ( intermediate_timestep_count < &
+                      intermediate_timestep_count_max )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb+1, nzt
+                         tni_m(k,j,i) =  -9.5625_wp * tend(k,j,i)             &
+                                         + 5.3125_wp * tni_m(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDIF
+
+          CALL cpu_log( log_point(69), 'ni-equation', 'stop' )
+
+       ENDIF
+
 !
 !--    If required, calculate prognostic equations for rain water content
@@ -1616,5 +1983,5 @@
                                              )                                 &
                                     * MERGE( 1.0_wp, 0.0_wp,                   &
-                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
                    IF ( qr_p(k,j,i) < 0.0_wp )  qr_p(k,j,i) = 0.0_wp
@@ -1708,5 +2075,5 @@
                                              )                                 &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
                    IF ( nr_p(k,j,i) < 0.0_wp )  nr_p(k,j,i) = 0.0_wp
@@ -1751,5 +2118,4 @@
 !> Control of microphysics for grid points i,j
 !------------------------------------------------------------------------------!
-
     SUBROUTINE bcm_prognostic_equations_ij( i, j, i_omp_start, tn )
 
@@ -1805,5 +2171,5 @@
                                        )                                 &
                                  * MERGE( 1.0_wp, 0.0_wp,                &
-                                    BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                         )
              IF ( qc_p(k,j,i) < 0.0_wp )  qc_p(k,j,i) = 0.0_wp
@@ -1864,5 +2230,5 @@
                                        )                                 &
                                  * MERGE( 1.0_wp, 0.0_wp,                &
-                                    BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                         )
              IF ( nc_p(k,j,i) < 0.0_wp )  nc_p(k,j,i) = 0.0_wp
@@ -1885,4 +2251,130 @@
 
        ENDIF
+
+!
+!--    If required, calculate prognostic equations for ice crystal mixing ratio
+!--    and ice crystal concentration
+       IF ( microphysics_ice_extension )  THEN
+!
+!--       Calculate prognostic equation for ice crystal mixing ratio
+          tend(:,j,i) = 0.0_wp
+          IF ( timestep_scheme(1:5) == 'runge' ) &
+          THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( advc_flags_s, i, j, qi, 'qi', flux_s_qi,      &
+                                 diss_s_qi, flux_l_qi, diss_l_qi,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
+             ELSE
+                CALL advec_s_pw( i, j, qi )
+             ENDIF
+          ELSE
+             CALL advec_s_up( i, j, qi )
+          ENDIF
+          CALL diffusion_s( i, j, qi,                                   &
+                            surf_def_h(0)%qisws, surf_def_h(1)%qisws,   &
+                            surf_def_h(2)%qisws,                        &
+                            surf_lsm_h%qisws,    surf_usm_h%qisws,      &
+                            surf_def_v(0)%qisws, surf_def_v(1)%qisws,   &
+                            surf_def_v(2)%qisws, surf_def_v(3)%qisws,   &
+                            surf_lsm_v(0)%qisws, surf_lsm_v(1)%qisws,   &
+                            surf_lsm_v(2)%qisws, surf_lsm_v(3)%qisws,   &
+                            surf_usm_v(0)%qisws, surf_usm_v(1)%qisws,   &
+                            surf_usm_v(2)%qisws, surf_usm_v(3)%qisws )
+
+!
+!--       Prognostic equation for ice crystal mixing ratio
+          DO  k = nzb+1, nzt
+             qi_p(k,j,i) = qi(k,j,i) + ( dt_3d *                         &
+                                                ( tsc(2) * tend(k,j,i) + &
+                                                  tsc(3) * tqi_m(k,j,i) )&
+                                                - tsc(5) * rdf_sc(k)     &
+                                                         * qi(k,j,i)     &
+                                       )                                 &
+                                 * MERGE( 1.0_wp, 0.0_wp,                &
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                        )
+             IF ( qi_p(k,j,i) < 0.0_wp )  qi_p(k,j,i) = 0.0_wp
+          ENDDO
+!
+!--       Calculate tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                DO  k = nzb+1, nzt
+                   tqi_m(k,j,i) = tend(k,j,i)
+                ENDDO
+             ELSEIF ( intermediate_timestep_count < &
+                      intermediate_timestep_count_max )  THEN
+                DO  k = nzb+1, nzt
+                   tqi_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
+                                     5.3125_wp * tqi_m(k,j,i)
+                ENDDO
+             ENDIF
+          ENDIF
+
+!
+!--       Calculate prognostic equation for ice crystal concentration.
+          tend(:,j,i) = 0.0_wp
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( advc_flags_s, i, j, ni, 'ni', flux_s_ni,      &
+                                 diss_s_ni, flux_l_ni, diss_l_ni,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
+             ELSE
+                CALL advec_s_pw( i, j, ni )
+             ENDIF
+          ELSE
+             CALL advec_s_up( i, j, ni )
+          ENDIF
+          CALL diffusion_s( i, j, ni,                                    &
+                            surf_def_h(0)%nisws, surf_def_h(1)%nisws,    &
+                            surf_def_h(2)%nisws,                         &
+                            surf_lsm_h%nisws,    surf_usm_h%nisws,       &
+                            surf_def_v(0)%nisws, surf_def_v(1)%nisws,    &
+                            surf_def_v(2)%nisws, surf_def_v(3)%nisws,    &
+                            surf_lsm_v(0)%nisws, surf_lsm_v(1)%nisws,    &
+                            surf_lsm_v(2)%nisws, surf_lsm_v(3)%nisws,    &
+                            surf_usm_v(0)%nisws, surf_usm_v(1)%nisws,    &
+                            surf_usm_v(2)%nisws, surf_usm_v(3)%nisws )
+
+!
+!--       Prognostic equation for ice crystal concentration
+          DO  k = nzb+1, nzt
+             ni_p(k,j,i) = ni(k,j,i) + ( dt_3d *                         &
+                                                ( tsc(2) * tend(k,j,i) + &
+                                                  tsc(3) * tni_m(k,j,i) )&
+                                                - tsc(5) * rdf_sc(k)     &
+                                                         * ni(k,j,i)     &
+                                       )                                 &
+                                 * MERGE( 1.0_wp, 0.0_wp,                &
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                        )
+             IF ( ni_p(k,j,i) < 0.0_wp )  ni_p(k,j,i) = 0.0_wp
+          ENDDO
+!
+!--       Calculate tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                DO  k = nzb+1, nzt
+                   tni_m(k,j,i) = tend(k,j,i)
+                ENDDO
+             ELSEIF ( intermediate_timestep_count < &
+                      intermediate_timestep_count_max )  THEN
+                DO  k = nzb+1, nzt
+                   tni_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
+                                     5.3125_wp * tni_m(k,j,i)
+                ENDDO
+             ENDIF
+          ENDIF
+
+       ENDIF
+
 !
 !--    If required, calculate prognostic equations for rain water content
@@ -1929,5 +2421,5 @@
                                        )                                 &
                                  * MERGE( 1.0_wp, 0.0_wp,                &
-                                    BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                         )
              IF ( qr_p(k,j,i) < 0.0_wp )  qr_p(k,j,i) = 0.0_wp
@@ -1988,5 +2480,5 @@
                                        )                                 &
                                  * MERGE( 1.0_wp, 0.0_wp,                &
-                                    BTEST( wall_flags_total_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                         )
              IF ( nr_p(k,j,i) < 0.0_wp )  nr_p(k,j,i) = 0.0_wp
@@ -2038,4 +2530,8 @@
                    nr => nr_1;    nr_p => nr_2
                 ENDIF
+                IF ( microphysics_ice_extension )  THEN
+                   qi => qi_1;    qi_p => qi_2
+                   ni => ni_1;    ni_p => ni_2
+                ENDIF
 
              CASE ( 1 )
@@ -2049,4 +2545,9 @@
                    nr => nr_2;    nr_p => nr_1
                 ENDIF
+                IF ( microphysics_ice_extension )  THEN
+                   qi => qi_2;    qi_p => qi_1
+                   ni => ni_2;    ni_p => ni_1
+                ENDIF
+
 
           END SELECT
@@ -2093,4 +2594,28 @@
        ENDIF
 
+       IF ( microphysics_ice_extension )  THEN
+!
+!--       Surface conditions ice crysral (Dirichlet)
+!--       Run loop over all non-natural and natural walls. Note, in wall-datatype
+!--       the k coordinate belongs to the atmospheric grid point, therefore, set
+!--       qr_p and nr_p at upward (k-1) and downward-facing (k+1) walls
+          DO  l = 0, 1
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, bc_h(l)%ns
+                i = bc_h(l)%i(m)
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+                qi_p(k+bc_h(l)%koff,j,i) = 0.0_wp
+                ni_p(k+bc_h(l)%koff,j,i) = 0.0_wp
+             ENDDO
+          ENDDO
+!
+!--       Top boundary condition for ice crystal (Dirichlet)
+          qi_p(nzt+1,:,:) = 0.0_wp
+          ni_p(nzt+1,:,:) = 0.0_wp
+
+       ENDIF
+
+
        IF ( microphysics_seifert )  THEN
 !
@@ -2129,4 +2654,8 @@
              nr_p(:,nys-1,:) = nr_p(:,nys,:)
           ENDIF
+          IF ( microphysics_ice_extension )  THEN
+             qi_p(:,nys-1,:) = qi_p(:,nys,:)
+             ni_p(:,nys-1,:) = ni_p(:,nys,:)
+          ENDIF
        ELSEIF ( bc_radiation_n )  THEN
           IF ( microphysics_morrison )  THEN
@@ -2138,4 +2667,8 @@
              nr_p(:,nyn+1,:) = nr_p(:,nyn,:)
           ENDIF
+          IF ( microphysics_ice_extension )  THEN
+             qi_p(:,nyn+1,:) = qi_p(:,nyn,:)
+             ni_p(:,nyn+1,:) = ni_p(:,nyn,:)
+          ENDIF
        ELSEIF ( bc_radiation_l )  THEN
           IF ( microphysics_morrison )  THEN
@@ -2147,4 +2680,8 @@
              nr_p(:,:,nxl-1) = nr_p(:,:,nxl)
           ENDIF
+          IF ( microphysics_ice_extension )  THEN
+             qi_p(:,:,nxl-1) = qi_p(:,:,nxl)
+             ni_p(:,:,nxl-1) = ni_p(:,:,nxl)
+          ENDIF
        ELSEIF ( bc_radiation_r )  THEN
           IF ( microphysics_morrison )  THEN
@@ -2155,4 +2692,8 @@
              qr_p(:,:,nxr+1) = qr_p(:,:,nxr)
              nr_p(:,:,nxr+1) = nr_p(:,:,nxr)
+          ENDIF
+          IF ( microphysics_ice_extension )  THEN
+             qi_p(:,:,nxr+1) = qi_p(:,:,nxr)
+             ni_p(:,:,nxr+1) = ni_p(:,:,nxr)
           ENDIF
        ENDIF
@@ -2433,4 +2974,16 @@
              ENDIF
              to_be_resorted => nc_av
+          ENDIF
+          IF ( mode == 'xy' ) grid = 'zu'
+
+       CASE ( 'ni_xy', 'ni_xz', 'ni_yz' )
+          IF ( av == 0 )  THEN
+             to_be_resorted => ni
+          ELSE
+             IF ( .NOT. ALLOCATED( ni_av ) ) THEN
+                ALLOCATE( ni_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ni_av = REAL( fill_value, KIND = wp )
+             ENDIF
+             to_be_resorted => ni_av
           ENDIF
           IF ( mode == 'xy' ) grid = 'zu'
@@ -2499,4 +3052,16 @@
           IF ( mode == 'xy' ) grid = 'zu'
 
+       CASE ( 'qi_xy', 'qi_xz', 'qi_yz' )
+          IF ( av == 0 )  THEN
+             to_be_resorted => qi
+          ELSE
+             IF ( .NOT. ALLOCATED( qi_av ) ) THEN
+                ALLOCATE( qi_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                qi_av = REAL( fill_value, KIND = wp )
+             ENDIF
+             to_be_resorted => qi_av
+          ENDIF
+          IF ( mode == 'xy' ) grid = 'zu'
+
        CASE ( 'ql_xy', 'ql_xz', 'ql_yz' )
           IF ( av == 0 )  THEN
@@ -2534,7 +3099,7 @@
              DO  k = nzb_do, nzt_do
                 local_pf(i,j,k) = MERGE( &
-                                     to_be_resorted(k,j,i),                      &
-                                     REAL( fill_value, KIND = wp ),              &
-                                     BTEST( wall_flags_total_0(k,j,i), flag_nr ) &
+                                     to_be_resorted(k,j,i),                    &
+                                     REAL( fill_value, KIND = wp ),            &
+                                     BTEST( wall_flags_total_0(k,j,i), flag_nr )     &
                                   )
              ENDDO
@@ -2595,4 +3160,15 @@
              ENDIF
              to_be_resorted => nc_av
+          ENDIF
+
+       CASE ( 'ni' )
+          IF ( av == 0 )  THEN
+             to_be_resorted => ni
+          ELSE
+             IF ( .NOT. ALLOCATED( ni_av ) ) THEN
+                ALLOCATE( ni_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ni_av = REAL( fill_value, KIND = wp )
+             ENDIF
+             to_be_resorted => ni_av
           ENDIF
 
@@ -2643,4 +3219,15 @@
           ENDIF
 
+       CASE ( 'qi' )
+          IF ( av == 0 )  THEN
+             to_be_resorted => qi
+          ELSE
+             IF ( .NOT. ALLOCATED( qi_av ) ) THEN
+                ALLOCATE( qi_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                qi_av = REAL( fill_value, KIND = wp )
+             ENDIF
+             to_be_resorted => qi_av
+          ENDIF
+
        CASE ( 'ql' )
           IF ( av == 0 )  THEN
@@ -2675,8 +3262,8 @@
           DO  j = nys, nyn
              DO  k = nzb_do, nzt_do
-                local_pf(i,j,k) = MERGE(                                         &
-                                     to_be_resorted(k,j,i),                      &
-                                     REAL( fill_value, KIND = wp ),              &
-                                     BTEST( wall_flags_total_0(k,j,i), flag_nr ) &
+                local_pf(i,j,k) = MERGE(                                       &
+                                     to_be_resorted(k,j,i),                    &
+                                     REAL( fill_value, KIND = wp ),            &
+                                     BTEST( wall_flags_total_0(k,j,i), flag_nr )     &
                                   )
              ENDDO
@@ -2750,4 +3337,16 @@
           CASE ( 'curvature_solution_effects_bulk' )
              READ ( 13 )  curvature_solution_effects_bulk
+
+          CASE ( 'microphysics_ice_extension' )
+             READ ( 13 )  microphysics_ice_extension
+
+          CASE ( 'ice_crystal_sedimentation' )
+             READ ( 13 )  ice_crystal_sedimentation
+
+          CASE ( 'in_init' )
+             READ ( 13 )  in_init
+
+          CASE ( 'start_ice_microphysics' )
+             READ ( 13 )  start_ice_microphysics
 
           CASE DEFAULT
@@ -2782,4 +3381,10 @@
        CALL rrd_mpi_io( 'aerosol_bulk', aerosol_bulk )
        CALL rrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
+       CALL rrd_mpi_io( 'start_ice_microphysics', start_ice_microphysics )
+       CALL rrd_mpi_io( 'microphysics_ice_extension', microphysics_ice_extension )
+       CALL rrd_mpi_io( 'in_init', in_init )
+       CALL rrd_mpi_io( 'ice_crystal_sedimentation', ice_crystal_sedimentation )
+
+
 
     END SUBROUTINE bcm_rrd_global_mpi
@@ -2846,4 +3451,17 @@
                 tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+          CASE ( 'ni' )
+             IF ( k == 1 )  READ ( 13 )  tmp_3d
+             ni(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+          CASE ( 'ni_av' )
+             IF ( .NOT. ALLOCATED( ni_av ) )  THEN
+                ALLOCATE( ni_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             ENDIF
+             IF ( k == 1 )  READ ( 13 )  tmp_3d
+             ni_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
           CASE ( 'nr' )
              IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -2886,4 +3504,17 @@
                 tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+          CASE ( 'qi' )
+             IF ( k == 1 )  READ ( 13 )  tmp_3d
+             qi(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+          CASE ( 'qi_av' )
+             IF ( .NOT. ALLOCATED( qi_av ) )  THEN
+                ALLOCATE( qi_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             ENDIF
+             IF ( k == 1 )  READ ( 13 )  tmp_3d
+             qi_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
+                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
           CASE ( 'qc_av' )
              IF ( .NOT. ALLOCATED( qc_av ) )  THEN
@@ -2984,4 +3615,16 @@
           CALL wrd_write_string( 'curvature_solution_effects_bulk' )
           WRITE ( 14 )  curvature_solution_effects_bulk
+
+          CALL wrd_write_string( 'start_ice_microphysics' )
+          WRITE ( 14 )  start_ice_microphysics
+
+          CALL wrd_write_string( 'microphysics_ice_extension' )
+          WRITE ( 14 )  microphysics_ice_extension
+
+          CALL wrd_write_string( 'in_init' )
+          WRITE ( 14 )  in_init
+
+          CALL wrd_write_string( 'ice_crystal_sedimentation' )
+          WRITE ( 14 )  ice_crystal_sedimentation
 
        ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
@@ -3001,4 +3644,8 @@
           CALL wrd_mpi_io( 'aerosol_bulk', aerosol_bulk )
           CALL wrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
+          CALL wrd_mpi_io( 'start_ice_microphysics', start_ice_microphysics )
+          CALL wrd_mpi_io( 'microphysics_ice_extension', microphysics_ice_extension )
+          CALL wrd_mpi_io( 'in_init', in_init )
+          CALL wrd_mpi_io( 'ice_crystal_sedimentation', ice_crystal_sedimentation )
 
        ENDIF
@@ -3062,4 +3709,25 @@
 
           ENDIF
+
+          IF ( microphysics_ice_extension )  THEN
+
+             CALL wrd_write_string( 'ni' )
+             WRITE ( 14 )  ni
+
+             IF ( ALLOCATED( ni_av ) )  THEN
+                CALL wrd_write_string( 'ni_av' )
+                WRITE ( 14 )  ni_av
+             ENDIF
+
+             CALL wrd_write_string( 'qi' )
+             WRITE ( 14 )  qi
+
+             IF ( ALLOCATED( qi_av ) )  THEN
+                CALL wrd_write_string( 'qi_av' )
+                WRITE ( 14 )  qi_av
+             ENDIF
+
+          ENDIF
+
 
           IF ( microphysics_seifert )  THEN
@@ -3104,4 +3772,10 @@
              IF ( ALLOCATED( qr_av ) )  CALL wrd_mpi_io( 'qr_av', qr_av )
           ENDIF
+          IF ( microphysics_ice_extension )  THEN
+             CALL wrd_mpi_io( 'ni', ni )
+             IF ( ALLOCATED( ni_av ) )  CALL wrd_mpi_io( 'ni_av', ni_av )
+             CALL wrd_mpi_io( 'qi', qi )
+             IF ( ALLOCATED( qi_av ) )  CALL wrd_mpi_io( 'qi_av', qi_av )
+          ENDIF
 
        ENDIF
@@ -3134,13 +3808,14 @@
 !--             Predetermine flag to mask topography
                 flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-                IF ( qr(k,j,i) <= eps_sb )  THEN
-                   qr(k,j,i) = 0.0_wp
-                   nr(k,j,i) = 0.0_wp
-                ELSE
-                   IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
-                      nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin * flag
-                   ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
-                      nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax * flag
+                IF ( .NOT. microphysics_morrison_no_rain )  THEN
+                   IF ( qr(k,j,i) <= eps_sb )  THEN
+                      qr(k,j,i) = 0.0_wp
+                      nr(k,j,i) = 0.0_wp
+                   ELSE
+                      IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
+                         nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin * flag
+                      ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
+                         nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax * flag
+                      ENDIF
                    ENDIF
                 ENDIF
